unit DSOX2000;

interface

uses Windows, Vcl.Forms, Classes, SysUtils,
   clipBrd, spin, Messages, registry, system.UITypes,
   jmmUtil, hpMain, HPgrapheMult, ActnList, ImgList,
   ToolWin, Controls, StdActns, ActnMan,
   Dialogs, ActnCtrls, ExtCtrls, ComCtrls, StdCtrls, math,
   libusb, AgilentU, Buttons, hpdde, System.Actions, optionsCSV,
  Vcl.XPStyleActnCtrls, System.ImageList;

type
   TDSOX2000OscilloForm = class(TForm)
      ActionManager1: TActionManager;
      ImageList1: TImageList;
      RegressiAction: TAction;
      StopAction: TAction;
      AboutAction: TAction;
      ActionToolBar1: TActionToolBar;
    Oscillo: TPaintBox;
    StatusBarKey: TStatusBar;
    UnLockAction: TAction;
    FileSaveAction: TFileSaveAs;
    NewPageAction: TAction;
    GroupBox1: TGroupBox;
    EditComm: TEdit;
    PanelValeur: TPanel;
    Edit1: TEdit;
    GroupBox5: TGroupBox;
    NomConstEdit: TLabeledEdit;
    UniteConstEdit: TLabeledEdit;
    ValeurConstEdit: TLabeledEdit;
    XYrg: TRadioGroup;
    StatusBar: TStatusBar;
    ExitAction: TAction;
    PasGB: TGroupBox;
    AttenteLabel: TLabel;
    DigitizeAction: TAction;
    CommEdit: TLabeledEdit;
    NbreCB: TComboBox;
    LabelNbreAgilent: TLabel;
    Label1: TLabel;
    HelpXY: TLabel;
    HelpXY2: TLabel;
    HelpClipped: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure SaveData(const NomFichier: string);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: char);
    procedure RegressiActionExecute(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure UnLockActionExecute(Sender: TObject);
    procedure FileSaveActionAccept(Sender: TObject);
    procedure NewPageActionExecute(Sender: TObject);
    procedure ExitActionExecute(Sender: TObject);
    procedure DigitizeActionExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
   private
      AcqFaite, AcqAsauver: boolean;
      GrapheOsc : TgrapheOsc;
      FichierRegressiCree : boolean;
      procedure SetBoutonAcq(Permis: boolean);
      procedure TestEnvoi(Aenvoi: Tenvoi);
      procedure EnvoieDonnees(envoi : Tenvoi);
   public
   protected
   end;

var
   DSOX2000OscilloForm: TDSOX2000OscilloForm;

implementation

{$R *.dfm}

const NombreTest = 5000;
      NbrePas = 6;
      NombreReg : array[0..NbrePas] of integer = (1024,2048,4096,8192,16384,32768,50000);

procedure TDSOX2000OscilloForm.ExitActionExecute(Sender: TObject);
begin
  Close
end;

procedure TDSOX2000OscilloForm.FormCreate(Sender: TObject);
var i : integer;
begin
   AcqFaite := False;
   AcqAsauver := False;
   GrapheOsc := TgrapheOsc.Create;
   GrapheOsc.paintBox := Oscillo;
   NbreCB.Items.Clear;
   for i := 0 to NbrePas do
       NbreCB.Items.Add(intToStr(NombreReg[i]));
   NbreCB.ItemIndex := 1;
   (*
{$IFDEF DEBUG}
      append(fichierDebug);
      writeln(fichierDebug,'Create DSOX2000Form');
      system.flush(fichierDebug);
      closeFile(fichierDebug);
{$ENDIF}
*)
end;

procedure TDSOX2000OscilloForm.SetBoutonAcq(permis: boolean);
begin
   DigitizeAction.Enabled := permis;
   RegressiAction.Enabled := permis and AcqFaite;
   FileSaveAction.Enabled := RegressiAction.Enabled;
   NewPageAction.enabled := RegressiAction.Enabled and FichierRegressiCree;
//   StopAction.Enabled := not permis;
end;

procedure TDSOX2000OscilloForm.SaveData(const NomFichier: string);
var
   fichier: textFile;

Procedure sautDeLigne;
begin
     write(Fichier,crLF)
end;

   procedure EcritPage;
   var
      j: indiceVecteurOsc;
      v: indiceVoieOsc;
   begin
         for j := agilent.debut to agilent.fin do begin
            Write(fichier, FloatToStr(agilent.valeursT[j]));
            for v := voie1 to voie2 do if agilent.voies[v].active then
                Write(fichier, separeValue,FloatToStr(agilent.valeurs[v,j]));
            sautDeLigne;
         end;
   end; // ecritPage

   procedure ecritEnTete;
   var
      j: integer;
   begin
         write(fichier, 'Acquisition par '+Agilent.identificateur);
         sautDeLigne;
         Write(fichier, agilent.voieT.nom);
         for j := voie1 to Voie2 do
            if agilent.voies[j].active then
               Write(fichier, separeValue, agilent.voies[j].nom);
         sautDeLigne;
         Write(fichier, agilent.voieT.nomUnite);
         for j := voie1 to Voie2 do
            if agilent.voies[j].active then
               Write(fichier, separeValue, agilent.voies[j].nomUnite);
         sautDeLigne;
         Write(fichier, agilent.voieT.signif);
         for j := voie1 to Voie2 do
            if agilent.voies[j].active then
               Write(fichier, separeValue, agilent.voies[j].signif);
         sautDeLigne;
   end; // ecritEnTete

begin
   Screen.Cursor := crHourGlass;
   if (XYrg.ItemIndex > 0)
      then agilent.chercheUnTour(XYrg.ItemIndex = 2);
   AssignFile(fichier, NomFichier);
   Rewrite(fichier);
   if not OptionsCSVForm.dataOnly then ecritEnTete;
   ecritPage;
   CloseFile(fichier);
   Screen.Cursor := crDefault;
   AcqAsauver := False;
end;

procedure TDSOX2000OscilloForm.OscilloPaint(Sender: TObject);
begin
   GrapheOsc.DrawG
end;

procedure TDSOX2000OscilloForm.FormActivate(Sender: TObject);
begin
   setBoutonAcq(True);
end;

procedure TDSOX2000OscilloForm.FormDestroy(Sender: TObject);
begin
   DSOX2000OscilloForm := nil
end;

procedure TDSOX2000OscilloForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   if AcqAsauver and
      (MessageDlg('Sauvegarde', mtConfirmation, [mbYes, mbNo], 0) = idYes)
   then FileSaveAction.Execute;
   AgilentFormMain.setMode(mNone);
end;

procedure TDSOX2000OscilloForm.FormKeyPress(Sender: TObject; var Key: char);
begin
   if (key = ' ') and DigitizeAction.Enabled then begin
        DigitizeAction.execute;
        key := #0;
   end;
end;

procedure TDSOX2000OscilloForm.FormShow(Sender: TObject);
begin
   setBoutonAcq(True);
end;

procedure TDSOX2000OscilloForm.NewPageActionExecute(Sender: TObject);
begin
     TestEnvoi(eAdd)
end;

procedure TDSOX2000OscilloForm.TestEnvoi(Aenvoi: Tenvoi);
var reponse : integer;
begin
   if pasGB.visible and (NbreCB.itemIndex>2) then begin
        reponse := application.messageBox(
        PWideChar('Nombre de points '+nbreCB.text+'. Vous tes sr ?'),
        PWideChar('Envoi  Regressi'),mb_yesnocancel);
        if reponse<>idyes then exit;
    end;
    envoieDonnees(Aenvoi)
end;

procedure TDSOX2000OscilloForm.RegressiActionExecute(Sender: TObject);
begin
    testEnvoi(eLoad)
end;

procedure TDSOX2000OscilloForm.EnvoieDonnees(envoi : Tenvoi);
var
   donnees: TStringList;

   procedure AjouteConstOsc;
   var
      valeurConst: double;
   begin
         if NomConstEdit.Text = '' then exit;
         ValeurConst := StrToFloatWin(ValeurConstEdit.Text);
         if isNan(valeurConst) then exit;
         donnees.Add('');
         donnees.Add(UnicodeVersRW3(NomConstEdit.Text));
         donnees.Add(UnicodeVersRW3(UniteConstEdit.Text));
//       if CommEdit.Text<>'' then donnees.Add(UnicodeVersRW3(CommEdit.Text));
         donnees.Add(valeurConstEdit.Text);
   end;

var
   i: indiceVecteurOsc;
   v: integer;
   ligne: String;
   valeur : double;
   erreurOsc : boolean;
   N,pas,j,jmax : integer;
begin
   Screen.Cursor := crHourGlass;
   if XYrg.ItemIndex > 0 then
       agilent.chercheUnTour(XYrg.ItemIndex = 2);
   pas := (agilent.fin-agilent.debut+1) div NombreReg[nbreCB.ItemIndex];
   jmax := NombreReg[nbreCB.ItemIndex];
   if pas<1 then pas := 1;
   N := 0;
   for v := voie1 to voie2 do
       if agilent.voies[v].active then inc(N);
   donnees := TStringList.Create;
   donnees.Add(Application.exeName);
   if envoi = eLoad
      then donnees.Add('Acquisition par ' + Agilent.identificateur)
      else donnees.Add('');
   donnees.Add(unicodeVersRW3(EditComm.Text));
   Ligne := unicodeVersRW3(agilent.voieT.nom);
   for v := voie1 to voie2 do
      with agilent.voies[v] do
         if active then
            ligne := ligne + crTab + unicodeVersRW3(nom);
   donnees.Add(ligne);
   Ligne := unicodeVersRW3(agilent.voieT.nomUnite);
   for v := voie1 to voie2 do
      with agilent.voies[v] do
         if active then
            ligne := ligne + crTab + unicodeVersRW3(nomUnite);
   donnees.Add(ligne);
   Ligne :=  unicodeVersRW3(agilent.voieT.Signif);
   for v := voie1 to voie2 do
      with agilent.voies[v] do
         if active then
            ligne := ligne + crTab + unicodeVersRW3(signif);
   donnees.Add(ligne);
   i := agilent.Debut;
   j := 0;
   while (i<=agilent.Fin) and (j<jmax) do begin
      ligne := floatToStrPoint(agilent.ValeursT[i]);
      erreurOsc := false;
      for v := voie1 to voie2 do
          if agilent.voies[v].active then begin
               valeur := agilent.Valeurs[v,i];
               erreurOsc := erreurOsc or isNan(valeur);
               if not erreurOsc then
                  ligne := ligne + crTab + floatToStrPoint(valeur);
          end;
      if not erreurOsc then donnees.Add(ligne);
      inc(i,pas);
      inc(j);
   end;
   AjouteConstOsc;
   if (envoi = eLoad) then begin
      if (XYrg.ItemIndex > 0) then begin
         donnees.Add(symbReg2 + '1 NOMX');
         donnees.Add(unicodeVersRW3(agilent.voies[voie1].nom));
         donnees.Add(symbReg2 + '1 NOMY');
         donnees.Add(unicodeVersRW3(agilent.voies[voie2].nom));
      end;
      donnees.Add(symbReg2+intToStr(N)+' COULEUR');
      for i := 1 to N do donnees.Add(IntToStr(couleurAgilent[i]));
      donnees.Add(symbReg2+intToStr(N)+' LIGNE');
      for i := 1 to N do donnees.Add('2');
   end;
   FormDDE.Execute(envoi, donnees,'');
   FichierRegressiCree := true;
   Donnees.Free;
   Screen.Cursor := crDefault;
   AcqAsauver := False;
end; // envoieDonnees

procedure TDSOX2000OscilloForm.FileSaveActionAccept(Sender: TObject);
begin
    SaveData(FileSaveAction.Dialog.FileName)
end;

procedure TDSOX2000OscilloForm.DigitizeActionExecute(Sender: TObject);
var tm : TTimeMode;
    etat : word;
    running : boolean;

procedure litMain;
var lent : boolean;
begin
  if running then begin
      BaseDeTemps := Agilent.GetFloat(':TIM:SCAL?',1e-4);
      lent := baseDeTemps>0.1;
      agilent.RootCommand('STOP');
      if not lent then agilent.RootCommand('DIG'); // tm MAIN or WIND
   end;
   agilent.litValeursInfiniVision;
   if running then agilent.rootCommand('RUN');
end;

procedure LitRoll;
begin
   if running then agilent.RootCommand('STOP');
   agilent.litValeursInfiniVision;
   if running then agilent.rootCommand('RUN');
end;

procedure LitXY;
begin
   //agilent.RootCommand('STOP');
   agilent.litValeursInfiniVision;
   XYrg.ItemIndex := 1;
   //agilent.rootCommand('RUN');
end;

begin
   AttenteLabel.Visible := true;
   unlockAction.Enabled := true;
   statusBar.simpleText := 'Lecture des donnes de l''oscilloscope';
   tm := agilent.TimeMode;
   HELPXY.Visible := tm=tmXY;
   HELPXY2.Visible := tm=tmXY;
   setBoutonAcq(False);
   etat := agilent.getInteger(':OPER:COND?',0); // 15 bits
   running := ((etat and $8)=$8); // bit 3 set RUN else STOP
   case tm of
      tmRoll : litRoll;
      tmXY : litXY;
      else litMain; // tmMain,tmWindow
   end;
   AcqFaite := not(agilent.stop) and (agilent.nbrePoints>16);
   setBoutonAcq(True);
   oscillo.refresh;
   statusBar.simpleText := 'Fin de lecture des donnes de l''oscilloscope';
   agilent.unLock;
   labelNbreAgilent.caption := 'Acquis : '+intToStr(agilent.NbrePoints);
   pasGB.Visible := (agilent.nbrePoints>1024);
   AttenteLabel.Visible := false;
 //  HelpClipped.Visible := agilent.clipped;
end;

procedure TDSOX2000OscilloForm.UnLockActionExecute(Sender: TObject);
begin
   agilent.unlock;
   unLockAction.Enabled := false;
end;

end.

