const
     degre = 2;
     ordre = degre+1;
type
   matrice = array[1..ordre,1..ordre+1] of extended;
   matriceLigne = array[1..ordre] of extended;
   EsystemeLineaireError = class(Exception);
   vectorPuiss = array[0..2*degre] of extended;

Procedure Resolution(A : matrice;ordre : byte;var Result : matriceLigne);
 { Cette procdure rsoud un systme AX = B }
 { crit sous la forme AX = A(n+1) }
 { par la mthode d'limination de Gauss (pivot partiel) }

  Procedure Elimination;

    FUNCTION Pivot(i :integer):integer;
    Var n,temp : integer;
    BEGIN
      temp := i;
      for n := i+1 to ordre do
          if abs(A[n,i]) > abs(A[i,i]) then temp:= n;
      pivot:=temp;
      if abs(A[temp,i]) <= 1e-100 then
         raise EsystemeLineaireError.Create('Erreur rsolution systme linaire')
    END;

    PROCEDURE Permute(i,j:integer);
    Var temp:extended;
        k:integer;
    BEGIN
       if i<>j then For k:=i to ordre+1 do BEGIN
          temp:=A[i,k];
          A[i,k]:=A[j,k];
          A[j,k]:=temp;
       END;
    END;

  var I,J,K : integer;
      M : extended;
  begin
    for k := 1 to ordre do begin
          Permute(k,pivot(k));
          for i:=k+1 to ordre do begin
              M := A[i,k]/A[k,k];
              for j:=k+1 to ordre+1 do A[i,j]:=A[i,j]-M*A[k,j];
              A[i,k]:=0.0;
          end;
       end;
    end; {Elimination}

    Procedure Substitution;
    var I,J : integer;
        S : extended;
    begin
         try
         for I:=ordre downto 1 do begin
             S:=A[I,ordre+1];
             for J:=I+1 to ordre do S:=S-A[I,J]*Result[J];
             Result[I]:=S/A[I,I];
         end;
         except
            on EzeroDivide do raise EsystemeLineaireError.Create('Erreur rsolution systme linaire')
         end;
    end;

begin {Resolution}
  Elimination;
  Substitution;
end; {rsolution}

procedure DeriveeGauss(const X,Y:Vecteur;N : integer;
   var Yder,Ysec : Vecteur);
var puissX : vectorPuiss;
    A : matrice;
    Coeff : matriceLigne;
    puissMax : byte;

procedure initXY;
var j : integer;
    loc : extended;
    i : byte;
begin
    for i := 1 to puissMax do puissX[i] := 0;
    puissX[0] := 3;
    for i := 1 to ordre do A[i,ordre+1] := 0;
    for j := 0 to 2 do begin
        loc := x[j];
        for i := 1 to puissMax do begin
            puissX[i] := puissX[i]+loc;
            loc := loc*x[j];
        end;
        loc := y[j];
        for i := 1 to ordre do begin
            A[i,ordre+1] := A[i,ordre+1]+loc;
            loc := loc*x[j];
        end;
    end;
end;

Procedure CalculXY(i : integer);
var ajoute,retire : extended;
    k : byte;
begin
        ajoute := X[i+1];
        retire := X[i-2];
        for k := 1 to puissMax do begin
            puissX[k] := puissX[k]+ajoute-retire;
            retire := retire*X[i-2];
            ajoute := ajoute*X[i+1];
        end;
        ajoute := Y[i+1];
        retire := Y[i-2];
        for k := 1 to ordre do begin
            A[k,ordre+1] := A[k,ordre+1]+ajoute-retire;
            retire := retire*X[i-2];
            ajoute := ajoute*X[i+1];
        end;
end;

procedure AffecteCoeff;
var i,j : byte;
begin
     for i := 1 to ordre do
         for j := 1 to ordre do
             A[i,j] := PuissX[i+j-2];
     Resolution(A,ordre,Coeff);
end;

Procedure AffecteDerivee(i : integer);
begin
     yder[i] := coeff[2]+2*coeff[3]*x[i];
     ysec[i] := 2*coeff[3];
end;

var i : integer;
begin { DeriveeGauss }
    puissMax := 2*degre;
    for i := 0 to pred(N) do yder[i] := sansSignif;
    initXY;
    try
    affecteCoeff;
    for i := 0 to 1 do affecteDerivee(i);
    for i := 2 to N-2 do begin
        calculXY(i);
        affecteCoeff;
        affecteDerivee(i);
    end;
    affecteDerivee(pred(N));
    except
    end;
end; { DeriveeGauss }

procedure AccelerationVect(const X,Y:Vecteur;N : integer;
   var acc : Vecteur);
var Yder : Vecteur;
begin
     DeriveeGauss(X,Y,N,Yder,acc)
end;

function AccelerationPoint(const X,Y:vecteur;Nbre : integer) : double;
var puissX : vectorPuiss;
    A : matrice;
    Coeff : matriceLigne;

procedure initXY;
var j : integer;
    loc : extended;
    i : byte;
    puissMax : byte;
begin
    puissMax := 2*degre;
    for i := 1 to puissMax do puissX[i] := 0;
    puissX[0] := 3;
    for i := 1 to ordre do A[i,ordre+1] := 0;
    for j := Nbre-1 to Nbre+1 do begin
        loc := x[j];
        for i := 1 to puissMax do begin
            puissX[i] := puissX[i]+loc;
            loc := loc*x[j];
        end;
        loc := y[j];
        for i := 1 to ordre do begin
            A[i,ordre+1] := A[i,ordre+1]+loc;
            loc := loc*x[j];
        end;
    end;
end;

var i,j : byte;
begin { AccelerationPoint }
    result := sansSignif;
    try
    initXY;
    for i := 1 to ordre do
         for j := 1 to ordre do
             A[i,j] := PuissX[i+j-2];
    Resolution(A,ordre,Coeff);
    result := 2*coeff[3];
    except
    end;
end; { AccelerationPoint }


