unit Hposc;

interface

uses Windows, Forms, Classes, SysUtils,
   clipBrd, spin, Messages, registry, system.UITypes,
   jmmUtil, hpMain, HPgrapheMult, ActnList, ImgList,
   ToolWin, Controls, StdActns, XPStyleActnCtrls, ActnMan,
   Dialogs, ActnCtrls, ExtCtrls, ComCtrls, StdCtrls, math,
   AgilentU, Buttons, System.Actions, optionsCSV, System.ImageList;

type
   TOscilloForm = class(TForm)
      ActionManager1: TActionManager;
      ImageList1: TImageList;
      RegressiAction: TAction;
      EnregistreAction: TAction;
      StopAction: TAction;
      AboutAction: TAction;
      GroupBox3: TGroupBox;
      ActionToolBar1: TActionToolBar;
      XYrg: TRadioGroup;
      SingleAction: TAction;
    Oscillo: TPaintBox;
    AutoScaleAction: TAction;
    StatusBarKey: TStatusBar;
    PanelReglage: TPanel;
    GroupBox6: TGroupBox;
    Label5: TLabel;
    BaseDeTempsLabel: TLabel;
    voie1GB: TGroupBox;
    Label7: TLabel;
    Calibre1Label: TLabel;
    voie2GB: TGroupBox;
    Label8: TLabel;
    Calibre2Label: TLabel;
    GroupBox9: TGroupBox;
    LevelLabel: TLabel;
    TriggerSourceRG: TRadioGroup;
    TriggerSlopeRG: TRadioGroup;
    TriggerModeRG: TRadioGroup;
    ProgressBar1: TProgressBar;
    PosXDnBtn: TSpeedButton;
    posXUpBtn: TSpeedButton;
    ScaleXDnBtn: TSpeedButton;
    ScaleXupBtn: TSpeedButton;
    posupBtn: TSpeedButton;
    posDnBtn: TSpeedButton;
    scaleUpBtn: TSpeedButton;
    scaleDnBtn: TSpeedButton;
    scale2UpBtn: TSpeedButton;
    Scale2DnBtn: TSpeedButton;
    pos2DnBtn: TSpeedButton;
    Pos2UpBtn: TSpeedButton;
    levelUpBtn: TSpeedButton;
    levelDnBtn: TSpeedButton;
    AcqModerG: TRadioGroup;
    SingleBtn: TBitBtn;
    UnLockAction: TAction;
    FileSaveAction: TFileSaveAs;
    TimerAutoScale: TTimer;
    NewPageAction: TAction;
    GroupBox4: TGroupBox;
    NomConstEdit: TLabeledEdit;
    UniteConstEdit: TLabeledEdit;
    ValeurConstEdit: TLabeledEdit;
    CommEdit: TLabeledEdit;
    ExitAction: TAction;
      procedure ExitItemClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure FormKeyPress(Sender: TObject; var Key: char);
      procedure RegressiActionExecute(Sender: TObject);
      procedure EnregistreActionExecute(Sender: TObject);
      procedure StopActionExecute(Sender: TObject);
    procedure SingleActionExecute(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure AutoScaleActionExecute(Sender: TObject);
    procedure posXUpBtnClick(Sender: TObject);
    procedure scaleUpBtnClick(Sender: TObject);
    procedure scaleDnBtnClick(Sender: TObject);
    procedure posupBtnClick(Sender: TObject);
    procedure posDnBtnClick(Sender: TObject);
    procedure levelUpBtnClick(Sender: TObject);
    procedure levelDnBtnClick(Sender: TObject);
    procedure TriggerSourceRGClick(Sender: TObject);
    procedure TriggerModeRGClick(Sender: TObject);
    procedure TriggerSlopeRGClick(Sender: TObject);
    procedure ScaleXupBtnClick(Sender: TObject);
    procedure UnLockActionExecute(Sender: TObject);
    procedure FileSaveActionAccept(Sender: TObject);
    procedure TimerAutoScaleTimer(Sender: TObject);
    procedure NewPageActionExecute(Sender: TObject);
    procedure ExitActionExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
   private
      AcqFaite, AcqAsauver,MajEnCours: boolean;
      GrapheOsc : TgrapheOsc;
      FichierRegressiCree : boolean;
      procedure SetBoutonAcq(Permis: boolean);
      procedure SauverData(NouveauFichier : boolean);
   public
      NbreZero: integer;
   protected
       procedure WMAcqRaz(var Message: Tmessage); message WM_Acq_Raz;
   end;

var
   OscilloForm: TOscilloForm;

implementation

uses Hpdde, libusb;

{$R *.dfm}

procedure TOscilloForm.ExitActionExecute(Sender: TObject);
begin
 Close;
end;

procedure TOscilloForm.ExitItemClick(Sender: TObject);
begin
   Close;
end;

procedure TOscilloForm.scaleDnBtnClick(Sender: TObject);
var numVoie : AnsiString;
begin
    numVoie := AnsiString(intToStr((sender as TspeedButton).tag));
    panelReglage.enabled := false;
    if agilent.usb=oRigol then begin
        agilent.KeyCommand('CHAN'+numVoie);
        agilent.KeyCommand('V_SCALE_DEC');
    end
    else agilent.KeyCommand('CH'+numVoie+'_SCALE_DEC');
    Perform(WM_Acq_Raz,0,0);
end;

procedure TOscilloForm.scaleUpBtnClick(Sender: TObject);
var numVoie : AnsiString;
begin
    numVoie := AnsiString(IntToStr((sender as TSpeedButton).tag));
    panelReglage.enabled := false;
    if agilent.usb=oRigol then begin
        agilent.KeyCommand('CHAN'+numVoie);
        agilent.KeyCommand('V_SCALE_INC');
      end
      else agilent.KeyCommand('CH'+numVoie+'_SCALE_INC');
    Perform(WM_Acq_Raz,0,0)
end;

procedure TOscilloForm.FormCreate(Sender: TObject);
begin
   AcqFaite := False;
   AcqAsauver := False;
   agilent.progressBar := progressBar1;
   GrapheOsc := TgrapheOsc.Create;
   GrapheOsc.paintBox := Oscillo;
end;

procedure TOscilloForm.SetBoutonAcq(permis: boolean);
begin
   EnregistreAction.Enabled := permis;
   RegressiAction.Enabled := permis and AcqFaite;
   FileSaveAction.Enabled := RegressiAction.Enabled;
   NewPageAction.Enabled := RegressiAction.Enabled and FichierRegressiCree;
   StopAction.Enabled := False;
end;

procedure TOscilloForm.SingleActionExecute(Sender: TObject);
begin
    panelReglage.enabled := false;
    stopAction.Enabled := true;
    UnLockAction.enabled := false;
    agilent.KeyCommand('SINGLE');
    Perform(WM_Acq_Raz,0,0);
end;

procedure TOscilloForm.posXUpBtnClick(Sender: TObject);
begin
    unlockAction.Enabled := true;
    if agilent.usb=oRigol then
     case (sender as TspeedButton).tag of
         0 : agilent.KeyCommand('H_POS_DEC');
         1 : agilent.KeyCommand('H_POS_INC');
         2 : agilent.KeyCommand('H_SCALE_DEC');
         3 : agilent.KeyCommand('H_SCALE_INC');
    end
    else case (sender as TspeedButton).tag of
         0 : agilent.KeyCommand('TIME_POS_DEC');
         1 : agilent.KeyCommand('TIME_POS_INC');
         2 : agilent.KeyCommand('TIME_SCALE_DEC');
         3 : agilent.KeyCommand('TIME_SCALE_INC');
    end;
end;

procedure TOscilloForm.ScaleXupBtnClick(Sender: TObject);
begin
    panelReglage.enabled := false;
    case (sender as TspeedButton).tag of
         0 : agilent.KeyCommand('TIME_POS_DEC');
         1 : agilent.KeyCommand('TIME_POS_INC');
         2 : agilent.KeyCommand('TIME_SCALE_DEC');
         3 : agilent.KeyCommand('TIME_SCALE_INC');
    end;
    Perform(WM_Acq_Raz,0,0)
end;


procedure TOscilloForm.OscilloPaint(Sender: TObject);
begin
   GrapheOsc.DrawG
end;

procedure TOscilloForm.posDnBtnClick(Sender: TObject);
var numVoie : AnsiString;
begin
    unlockAction.Enabled := true;
    numVoie := AnsiString(intToStr((sender as TspeedButton).tag));
    agilent.KeyCommand('CH'+numVoie+'_POS_DEC');
end;

procedure TOscilloForm.posupBtnClick(Sender: TObject);
var numVoie : ansiString;
begin
    unlockAction.Enabled := true;
    numVoie := AnsiString(IntToStr((sender as TspeedButton).tag));
    agilent.KeyCommand('CH'+numVoie+'_POS_INC');
end;

procedure TOscilloForm.FormDestroy(Sender: TObject);
begin
   OscilloForm := nil;
end;

procedure TOscilloForm.FormActivate(Sender: TObject);
begin
    unlockAction.Enabled := true;
    agilent.writeString(':BEEP:ENAB OFF');
end;

procedure TOscilloForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   if AcqAsauver and
      (MessageDlg('Sauvegarde', mtConfirmation, [mbYes, mbNo], 0) = idYes)
   then FileSaveAction.Execute;
   AgilentFormMain.setMode(mNone);
end;

procedure TOscilloForm.FormKeyPress(Sender: TObject; var Key: char);
begin
   if (key = ' ') and enregistreAction.Enabled then
            EnregistreAction.execute;
   key := #0;
end;

procedure TOscilloForm.levelDnBtnClick(Sender: TObject);
begin
    unlockAction.Enabled := true;
    agilent.KeyCommand('TRIG_LVL_DEC'); // Rigol OK
end;

procedure TOscilloForm.levelUpBtnClick(Sender: TObject);
begin
   unlockAction.Enabled := true;
   agilent.KeyCommand('TRIG_LVL_INC');  // Rigol OK
end;

procedure TOscilloForm.RegressiActionExecute(Sender: TObject);
begin
     SauverData(true)
end;

procedure TOscilloForm.SauverData(NouveauFichier : boolean);
var
   donnees: TStringList;

   procedure AjouteConst;
   var
      valeurConst: double;
   begin
         if NomConstEdit.Text = '' then exit;
         ValeurConst := StrToFloatWin(ValeurConstEdit.Text);
         if isnan(valeurConst) then exit;
         donnees.Add('');
         donnees.Add(UnicodeVersRW3(NomConstEdit.Text));
         donnees.Add(UnicodeVersRW3(UniteConstEdit.Text));
//       if CommEdit.Text<>'' then donnees.Add(UnicodeVersRW3(CommEdit.Text));
         donnees.Add(valeurConstEdit.Text);
   end;

var
   i: indiceVecteurOsc;
   v,pas: integer;
   ligne: string;
   N,NbrePointsRW3 : integer;
begin
   Screen.Cursor := crHourGlass;
   if (XYrg.ItemIndex > 1) then
      agilent.chercheUnTour(XYrg.ItemIndex = 3);
   N := 0;
   for v := voie1 to voie2 do
       if agilent.voies[v].active then inc(N);
   NbrePointsRW3 := agilent.NbrePoints;
   pas := (agilent.fin-agilent.debut) div NbrePointsRW3;
   if pas<1 then pas := 1;
   donnees := TStringList.Create;
   if nouveauFichier then begin
      donnees.Add(Application.exeName);
      donnees.Add('Acquisition par ' + Agilent.identificateur)
   end;
   donnees.Add(CommEdit.Text);
   Ligne := agilent.voieT.nom;
   for v := voie1 to voie2 do
      with agilent.voies[v] do if active then
            ligne := ligne + crTab+nom;
   donnees.Add(ligne);
   Ligne := agilent.voieT.nomUnite;
   for v := voie1 to voie2 do
      with agilent.voies[v] do
         if active then ligne := ligne + crTab+nomUnite;
   donnees.Add(ligne);
   Ligne := agilent.voieT.signif;
   for v := voie1 to voie2 do
      with agilent.voies[v] do if active then
            ligne := ligne + crTab+signif;
   donnees.Add(ligne);
   for i := agilent.Debut to agilent.Fin do if (i mod pas)=0 then begin
      ligne := floatToStrPoint(agilent.ValeursT[i]);
      for v := voie1 to voie2 do
          if agilent.voies[v].active then
               ligne := ligne + crTab + floatToStrPoint(agilent.Valeurs[v,i]);
      donnees.Add(ligne);
   end;
   AjouteConst;
   if (XYrg.ItemIndex > 1) and
      nouveauFichier then begin
      donnees.Add(symbReg2 + '1 NOMX');
      donnees.Add(agilent.voies[voie1].nom);
      donnees.Add(symbReg2 + '1 NOMY');
      donnees.Add(agilent.voies[voie2].nom);
   end;
   if nouveauFichier then begin
      donnees.Add(symbReg2+intToStr(N)+' COULEUR');
      for i := 1 to N do donnees.Add(IntToStr(couleurAgilent[i]));
          donnees.Add(symbReg2+intToStr(N)+' LIGNE');
      for i := 1 to N do donnees.Add('2'); // ligne
   end;
   if nouveauFichier
      then FormDDE.Execute(eLOAD, donnees,'')
      else FormDDE.Execute(eADD, donnees,'');
   FichierRegressiCree := true;
   Donnees.Free;
   Screen.Cursor := crDefault;
   AcqAsauver := False;
end;

procedure TOscilloForm.FileSaveActionAccept(Sender: TObject);
var
   fichier: textFile;
   nomFichier : string;

Procedure sautDeLigne;
begin
    write(Fichier,crLF)
end;

   procedure EcritPage;
   var
      j: indiceVecteurOsc;
      v: indiceVoieOsc;
   begin
         for j := 0 to pred(agilent.NbrePoints) do begin
            Write(fichier, FloatToStr(agilent.valeursT[j]));
            for v := voie1 to voie2 do if agilent.voies[v].active then
                Write(fichier, separeValue,FloatToStr(agilent.valeurs[v,j]));
            sautDeLigne;
         end;
   end; // ecritPage

   procedure ecritEnTete;
   var
      j: integer;
   begin
         write(fichier, 'Agilent DSOx000');
         sautDeLigne;
         Write(fichier, unicodeVersRW3(agilent.voieT.nom));
         for j := voie1 to Voie2 do if agilent.voies[j].active then
               Write(fichier, separeValue, unicodeVersRW3(agilent.voies[j].nom));
         sautDeLigne;
         Write(fichier, unicodeVersRW3(agilent.voieT.nomUnite));
         for j := voie1 to Voie2 do if agilent.voies[j].active then
               Write(fichier, separeValue, unicodeVersRW3(agilent.voies[j].nomUnite));
         sautDeLigne;
         Write(fichier, unicodeVersRW3(agilent.voieT.signif));
         for j := voie1 to Voie2 do if agilent.voies[j].active then
               Write(fichier, separeValue, unicodeVersRW3(agilent.voies[j].signif));
         sautDeLigne;
   end; // ecritEnTete

var extension : string;
begin
   Screen.Cursor := crHourGlass;
   nomFichier := FileSaveAction.Dialog.FileName;
   extension := AnsiUpperCase(ExtractFileExt(NomFichier));
   if extension='' then extension := '.CSV';
   nomFichier := nomFichier+extension;
   if (XYrg.ItemIndex > 1) then
      agilent.chercheUnTour(XYrg.ItemIndex = 3);
   AssignFile(fichier, NomFichier);
   Rewrite(fichier);
   if not OptionsCSVForm.dataOnly then ecritEnTete;
   ecritPage;
   CloseFile(fichier);
   Screen.Cursor := crDefault;
   AcqAsauver := False;
end;

procedure TOscilloForm.AutoScaleActionExecute(Sender: TObject);
begin
    panelReglage.enabled := false;
    stopAction.enabled := true;
    UnLockAction.enabled := true;
    timerAutoScale.enabled := true;
    if agilent.usb=oRigol
       then agilent.KeyCommand('AUTO')
       else agilent.KeyCommand('AUTO_SCALE');
    agilent.unLock;
end;

procedure TOscilloForm.NewPageActionExecute(Sender: TObject);
begin
    SauverData(true);
end;

procedure TOscilloForm.EnregistreActionExecute(Sender: TObject);
var reponse : string;
begin
   setBoutonAcq(False);
   stopAction.enabled := true;
   UnLockAction.enabled := true;
   reponse := string(agilent.getString(':ACQ:TYPE?')); // Rigol OK
   if pos('NORM',reponse)>0 then acqModeRG.itemIndex := 0;
   if pos('AVER',reponse)>0 then acqModeRG.itemIndex := 1;
   if pos('PEAK',reponse)>0 then acqModeRG.itemIndex := 2;
   if acqModeRG.itemIndex=2
      then agilent.litValeurs(wMaxPeak)
      else if XYRG.ItemIndex=1
         then agilent.litValeurs(wMemory)
         else agilent.litValeurs(wScreen);
   AcqFaite := agilent.nbrePoints>16;
   stopAction.enabled := false;
   agilent.unlock;
   UnLockAction.enabled := true;
   oscillo.refresh;
   setBoutonAcq(True);
end;

procedure TOscilloForm.StopActionExecute(Sender: TObject);
begin
   agilent.stop := True
end;

procedure TOscilloForm.TimerAutoScaleTimer(Sender: TObject);
begin
  timerAutoScale.Enabled := false;
  Perform(WM_Acq_Raz,0,0);
end;

procedure TOscilloForm.TriggerModeRGClick(Sender: TObject);
begin
     if majEnCours then exit;
     panelReglage.enabled := false;
     case TriggerModeRG.itemIndex of
          0 : agilent.trigCommand('SWE AUTO'); // Rigol OK
          1 : agilent.trigCommand('SWE NORM');
     end;
     levelLabel.visible := TriggerModeRG.itemIndex=1;
     levelUpBtn.visible := TriggerModeRG.itemIndex=1;
     levelDnBtn.visible := TriggerModeRG.itemIndex=1;
     Perform(WM_Acq_Raz,0,0);
end;

procedure TOscilloForm.TriggerSlopeRGClick(Sender: TObject);
var prefixe : AnsiString;
begin
     if majEnCours then exit;
     panelReglage.enabled := false;
     if agilent.usb=oRigol then prefixe := 'EDGE:' else prefixe := '';
     case TriggerSlopeRG.itemIndex of
          0 : agilent.trigCommand(prefixe+'SLOP POS');
          1 : agilent.trigCommand(prefixe+'SLOP NEG');
     end;
     Perform(WM_Acq_Raz,0,0);
end;

procedure TOscilloForm.TriggerSourceRGClick(Sender: TObject);
begin
    if majEnCours then exit;
    panelReglage.enabled := false;
    if agilent.usb=oRigol then
         case TriggerSourceRG.itemIndex of
         0 : agilent.trigCommand('SOUR CH1');
         1 : agilent.trigCommand('SOUR CH2');
         2 : agilent.trigCommand('SOUR EXT');
    end
	  else case TriggerSourceRG.itemIndex of
         0 : agilent.trigCommand('SOUR CHAN1');
         1 : agilent.trigCommand('SOUR CHAN2');
         2 : agilent.trigCommand('SOUR EXT');
    end;
    Perform(WM_Acq_Raz,0,0);
end;

procedure TOscilloForm.UnLockActionExecute(Sender: TObject);
begin
    agilent.unlock;
    unlockAction.Enabled := false;
end;

procedure TOscilloForm.WMAcqRaz(var Message: Tmessage);
var reponse : string;
    zz : double;
begin
    if isNan(baseDeTemps) then baseDeTemps := 0.01;
    if baseDeTemps<0.05
       then sleep(round(baseDeTemps*30000)+100)
       else sleep(1500);

    stopAction.enabled := true;
    UnLockAction.enabled := true;
    agilent.litValeurs(wScreen);
    oscillo.refresh;

    MajEnCours := true;

    BaseDeTemps := agilent.getFloat(':TIM:SCAL?',1e-4);  // Rigol OK
    BaseDeTempsLabel.caption := ' '+formatCourt(BaseDeTemps,'s/div ');

// mode Roll > 50 ms / div et Trigger auto    

    zz := agilent.getFloat(':CHAN1:SCAL?',2);
    Calibre1Label.caption := ' '+formatCourt(zz,'V/div ');
    scaleDnBtn.Enabled := zz<5;
    scaleUpBtn.Enabled := zz>0.0021;

    zz := agilent.getFloat(':CHAN2:SCAL?',2);  // Rigol OK
    Calibre2Label.caption := ' '+formatCourt(zz,'V/div ');
    scale2DnBtn.Enabled := zz<5;
    scale2UpBtn.Enabled := zz>0.0021;

    reponse := string(agilent.getString(':TRIG:SOUR?')); // Rigol OK
    if pos('1',reponse)>0 then triggerSourceRG.itemIndex := 0;
    if pos('2',reponse)>0 then triggerSourceRG.itemIndex := 1;
    if pos('EXT',reponse)>0 then triggerSourceRG.itemIndex := 2;

    if agilent.usb=oRigol
       then reponse := string(agilent.getString(':TRIG:EDGE:SLOP?'))
       else reponse := string(agilent.getString(':TRIG:SLOP?'));
    if pos('NEG',reponse)>0 then triggerSlopeRG.itemIndex := 1;
    if pos('POS',reponse)>0 then triggerSlopeRG.itemIndex := 0;

    reponse := string(agilent.getString(':ACQ:TYPE?'));
    if pos('NORM',reponse)>0 then acqModeRG.itemIndex := 0;
    if pos('AVER',reponse)>0 then acqModeRG.itemIndex := 1;
    if pos('PEAK',reponse)>0 then acqModeRG.itemIndex := 2;

    setBoutonAcq(True);
    MajEnCours := false;
    panelReglage.enabled := true;
    agilent.UnLock;
end;

end.

