
unit HPbode;

interface

uses
  System.Classes, System.Actions,
  Vcl.ActnList, Vcl.PlatformDefaultStyleActnCtrls, Vcl.ActnMan,
  System.ImageList, system.UITypes,
  Vcl.ImgList, Vcl.Forms, Vcl.StdActns,   Vcl.StdCtrls,
  Vcl.Controls, Vcl.ComCtrls, Vcl.ToolWin, Vcl.ActnCtrls, Vcl.ExtCtrls,
  Windows, Graphics, Menus,
  Dialogs,  Buttons,  sysUtils, Messages,
  clipBrd, spin, Registry, math,
  CustomizeDlg,
  libusb, AgilentU,  FloatEdit,
  jmmUtil,  HPdde, HPgrapheMult, optionsCSV;

type

  TTrackBar = class(Vcl.ComCtrls.TTrackBar)
  published
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;

  TBodeForm = class(TForm)
    PanelValeur: TPanel;
    PhaseGB: TGroupBox;
    GainGB: TGroupBox;
    GroupBoxFreq: TGroupBox;
    LabelFreq: TLabel;
    GainLabel: TLabel;
    PhaseLabel: TLabel;
    ImageList1: TImageList;
    Panel1: TPanel;
    Oscillo: TPaintBox;
    OscilloBis: TPaintBox;
    Edit1: TEdit;
    SplitterOscillo: TSplitter;
    EditMini: TFloatEdit;
    EditMaxi: TFloatEdit;
    Label4: TLabel;
    Label6: TLabel;
    PhaseCB: TCheckBox;
    LabelErreurLecture: TLabel;
    ActionManager1: TActionManager;
    EnregistreAction: TAction;
    StopAction: TAction;
    ResetAction: TAction;
    UnLockAction: TAction;
    NewPageAction: TAction;
    RegressiAction: TAction;
    ToolBar1: TActionToolBar;
    GroupBox4: TGroupBox;
    NomEdit: TLabeledEdit;
    UniteEdit: TLabeledEdit;
    ValeurConstEdit: TLabeledEdit;
    CommEdit: TLabeledEdit;
    GroupBox2: TGroupBox;
    ProgressBar: TProgressBar;
    dbCB: TCheckBox;
    FrequenceTB: TTrackBar;
    UndoAction: TAction;
    VeffEdit: TFloatEdit;
    AideAction: TAction;
    FileSaveAction: TFileSaveAs;
    BodeManuelCB: TCheckBox;
    EditPas: TFloatEdit;
    PasLabel: TLabel;
    LabelGBFCH1: TLabel;
    LabelInfo: TLabel;
    GBFLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure EnregistreExec(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ResetActionExec(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OscilloBisPaint(Sender: TObject);
    procedure StopActionExecute(Sender: TObject);
    procedure EditMiniChange(Sender: TObject);
    procedure EditMaxiChange(Sender: TObject);
    procedure EditMiniExit(Sender: TObject);
    procedure EditMaxiExit(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure dbCBClick(Sender: TObject);
    procedure VeffEditExit(Sender: TObject);
    procedure NewPageActionExecute(Sender: TObject);
    procedure RegressiActionExecute(Sender: TObject);
    procedure UnLockActionExecute(Sender: TObject);
    procedure UndoActionExecute(Sender: TObject);
    procedure VeffEditChange(Sender: TObject);
    procedure AideActionExecute(Sender: TObject);
    procedure FileSaveActionAccept(Sender: TObject);
    procedure BodeManuelCBClick(Sender: TObject);
  private
    GrapheMult : TgrapheMult;
    GrapheOsc : TgrapheOsc;
    multFreq : double; // multiplicateur de frquence en log
    frequenceCourante : double;
    acqEnCours,acqASauver : boolean;
    fichierRegressiCree : boolean;
    procedure setBoutons(actif : boolean);
    procedure EnvoieDonnees(Ordre : Tenvoi);
    procedure EnvoieDemande;
    procedure InitOscillo;
  public
   gbfInterne : boolean;

  procedure TrackBarMouseUp(Sender: TObject; Button: TMouseButton;
                                Shift: TShiftState; X, Y: Integer);
  protected
    procedure WMAcqPoint(var Msg: Tmessage); message WM_Acq_Point;
  end;

var
  BodeForm: TBodeForm;

implementation

uses voies, HPmain, AideBodeU;

const NbreMin = 8;
      NbreMax = 4096;
      multMax = 1.25; // 10 points par dcade
      multMin = 1.02; // 100 points par dcade

{$R *.DFM}


procedure TBodeForm.FormCreate(Sender: TObject);

Procedure Defaut;
var j : indiceVoieMult;
begin with grapheMult do begin
       with voies[voieF] do begin
              Nom := 'f';
              nomUnite := 'Hz';
              Signif := 'frquence';
              Positive := true;
              CalculIncertitude := ciNone;
              Mini := 100;
              Maxi := 1000;
              frequenceCourante := mini;
              NumVoie := voie1;
              axeLog := true;
              editMini.value := mini;
              editMaxi.value := maxi;
              LabelVoie := LabelFreq;
              GBvoie := GroupBoxFreq;
              LabelVoie.font.color := color;
        end;
        for j := voie1 to Voie2 do with voies[j] do begin
              Nom := 'V'+intTostr(j);
              nomUnite := 'V';
              Signif := 'tension efficace';
              Positive := true;
              CalculIncertitude := ciTensionEff;
              Mini := 0;
              Maxi := 10;
              NumVoie := j;
              active := false;
        end;
        with voies[voiePhase] do begin
              Nom := 'phi';
              nomUnite := '';
              Signif := 'Phase 1/2';
              Positive := false;
              CalculIncertitude := ciPhase;
              Mini := -185;
              Maxi := +185;
              NumVoie := voie1;
              LabelVoie := PhaseLabel;
              LabelVoie.font.color := color;
              GBvoie := PhaseGB;
              active := PhaseCB.Checked;
        end;
        with voies[voieGain] do begin
              Nom := 'G';
              Signif := 'Gain';
              Positive := true;
              CalculIncertitude := ciGain;
              Mini := 0;
              MiniLog := 0.009;
              Maxi := 1.5;
              NumVoie := voie1;
              axeLog := dbCB.checked;
              if dbCB.checked
                 then nomUnite := 'dB'
                 else nomUnite := '';
              LabelVoie := GainLabel;
              LabelVoie.font.color := color;
              GBVoie := GainGB;
              active := true;
        end;
     multFreq := power(10,1/10); // 10 points par dcade
end end;

begin
  GrapheOsc := TgrapheOsc.Create;
  GrapheOsc.paintBox := OscilloBis;
  GrapheMult := TgrapheMult.Create;
  GrapheMult.paintBox := Oscillo;
  agilent.progressBar := progressBar;
  FrequenceTB.onMouseUp := TrackBarMouseUp;
  Defaut;
end;

procedure TBodeForm.EnregistreExec(Sender: TObject);
begin
     if (grapheMult.nbrePoints>0) and
       (grapheMult.voies[voieF].valeur[pred(grapheMult.nbrePoints)]>=
        grapheMult.voies[voieF].maxi) and
       OK('Suppression des donnes courantes') then begin
         grapheMult.nbrePoints := 0;
    end;
    if grapheMult.nbrePoints=0
       then InitOscillo
       else begin // on continue
         frequenceCourante := frequenceCourante*multFreq;
         if frequenceCourante>grapheMult.voies[voieF].maxi then exit;
       end;
    grapheMult.voies[voiePhase].active := phaseCB.Checked;
    acqEnCours := true;
    PostMessage(handle,WM_Acq_Point,1,0)
end;

procedure TBodeForm.OscilloPaint(Sender: TObject);
begin
    GrapheMult.DrawG(not acqEnCours);
    labelErreurLecture.top := oscillo.Top+48;
    labelGBFCH1.top := oscillo.Top+16;
    labelInfo.top := oscillo.Top+96;
end;

procedure TBodeForm.FormClose(Sender: TObject;var Action: TCloseAction);
begin
    if stopAction.enabled then begin
        Agilent.stop := true;
        sleep(300);
    end;
    if AcqAsauver and
      (MessageDlg('Sauvegarde', mtConfirmation, [mbYes, mbNo], 0) = idYes)
          then FileSaveAction.Execute;
    if unlockAction.enabled then unLockActionExecute(sender);
    AgilentFormMain.setMode(mNone);
end;

procedure TBodeForm.RegressiActionExecute(Sender: TObject);
begin
     if newPageAction.enabled
         then newPageActionExecute(sender)
         else EnvoieDonnees(eLoad);
end;

procedure TBodeForm.EnvoieDonnees(Ordre : Tenvoi);
var donnees : TstringList;

procedure AjouteConst;
var valeurConst : double;
begin
     if NomEdit.text='' then exit;
     ValeurConst := StrToFloatWin(ValeurConstEdit.text);
     if isNan(valeurConst) then exit;
     donnees.Add('');
     donnees.Add(NomEdit.text);
     donnees.Add(UniteEdit.text);
     donnees.Add(valeurConstEdit.text);
end;

procedure AjouteCodeGraphe;
var N,i : integer;
begin with grapheMult do begin
      N := 2; // frquence et gain
      if voies[voiePhase].active then inc(N);
      donnees.Add(symbReg2 + intToStr(N)+' NOMX');
      for i := 1 to N do donnees.Add('f');
      donnees.Add(symbReg2 + intToStr(N) +' NOMY');
      donnees.Add(voies[voieGain].nom);
      if voies[voiePhase].active then
          donnees.Add(voies[voiePhase].nom);
      donnees.Add(symbReg2+intToStr(N)+' COULEUR');
      donnees.Add(IntToStr(voies[voieGain].color));
      if voies[voiePhase].active then
          donnees.Add(IntToStr(voies[voiePhase].color));
      donnees.Add(symbReg2+intToStr(N)+' LIGNE');
      for i := 1 to N do donnees.Add('1');
end end;

var i : indiceVecteur;
    j : indiceVoieMult;
    ligne : String;
begin with grapheMult do begin
     Screen.Cursor := crHourGlass;
     donnees := TstringList.create;
     if ordre=eLoad then begin
        donnees.Add(Application.exeName);
        donnees.Add(caption)
     end;
     donnees.Add(unicodeVersRW3(CommEdit.text));
     Ligne := 'f';
     for j := voiePhase to VoieGain do with voies[j] do if active then
         ligne := ligne + crTab + nom;
     donnees.Add(ligne);
     Ligne := 'Hz';
     for j := voiePhase to VoieGain do with voies[j] do if active then
         ligne := ligne + crTab + nomUnite;
     donnees.Add(ligne);
     Ligne := 'frquence';
     for j := voiePhase to VoieGain do with voies[j] do if active then
         ligne := ligne + crTab + commentaire;
     donnees.Add(ligne);
     for i := 0 to pred(NbrePoints) do begin
         ligne := FloatToStrPoint(voies[voieF].valeur[i]);
         for j := voiePhase to VoieGain do if active then
            ligne := ligne + crtab + FloatToStrPoint(voies[j].valeur[i]);
         donnees.Add(ligne);
     end;
     donnees.Add(symbReg2+IntToStr(NbrePoints)+' INCERT');
     for i := 0 to pred(NbrePoints) do begin
         ligne :=  FloatToStrPoint(voies[voieF].incertitude[i]);
         for j := voiePhase to VoieGain do if active then
             ligne := ligne + crtab + FloatToStrPoint(voies[j].incertitude[i]);
         donnees.Add(ligne);
     end;
     ajouteConst;
     ajouteCodeGraphe;
     FormDDE.Execute(ordre,donnees,'');
     FichierRegressiCree := true;
     Donnees.free;
     Screen.Cursor := crDefault;
     AcqASauver := false;
end end; // EnvoieDonnees

procedure TBodeForm.ResetActionExec(Sender: TObject);
begin
     if (grapheMult.NbrePoints=0) or
        (OK('Suppression des donnes courantes')) then begin
        Agilent.stop := true;
        GrapheMult.NbrePoints := 0;
        ResetAction.Enabled := false;
        RegressiAction.Enabled := false;
        NewPageAction.Enabled := false;
        FileSaveAction.Enabled := false;
        stopAction.enabled := true;
        oscilloBis.repaint;
        toolBar1.enabled := true;
        stopAction.enabled := false;
        enregistreAction.enabled := true;
        UnLockActionExecute(nil);
        acqEnCours := false;
        acqAsauver := false;
        Oscillo.repaint;
     end;
end;

procedure TBodeForm.FileSaveActionAccept(Sender: TObject);
var
   fichier: textFile;
   nomFichier : string;

Procedure sautDeLigne;
begin
    write(Fichier,crLF)
end;

   procedure EcritPage;
   var
      j: indiceVecteurOsc;
   begin with grapheMult do
         for j := 0 to pred(NbrePoints) do begin
            Write(fichier, FloatToStr(voies[voieF].valeur[j]));
            Write(fichier, separeValue,FloatToStr(voies[voieGain].valeur[j]));
            if grapheMult.voies[voiePhase].active then
                Write(fichier, separeValue,FloatToStr(voies[voiePhase].valeur[j]));
            sautDeLigne;
         end;
   end; // ecritPage

   procedure ecritEnTete;
   begin
         write(fichier, 'Agilent DSOx2000');
         sautDeLigne;
         Write(fichier, 'f');
         Write(fichier, separeValue, 'G');
         if grapheMult.voies[voiePhase].active then
               Write(fichier, separeValue, unicodeVersRW3(phi));
         sautDeLigne;
         Write(fichier, 'Hz');
         Write(fichier, separeValue, 'G');
         if grapheMult.voies[voiePhase].active then
            Write(fichier, separeValue, '');
         sautDeLigne;
   end; // ecritEnTete

var
   extension : string;
begin
   Screen.Cursor := crHourGlass;
   nomFichier := FileSaveAction.Dialog.FileName;
   extension := AnsiUpperCase(ExtractFileExt(NomFichier));
   if extension='' then extension := '.CSV';
   nomFichier := nomFichier+extension;
   AssignFile(fichier, NomFichier);
   Rewrite(fichier);
   ecritEnTete;
   ecritPage;
   CloseFile(fichier);
   AcqAsauver := false;
   Screen.Cursor := crDefault;
end;

procedure TBodeForm.FormActivate(Sender: TObject);
begin
   EnregistreAction.enabled := true;
   StopAction.enabled := false;
   oscilloBis.visible := agilent.usb=oLibUsb;
   splitterOscillo.visible := oscilloBis.visible;
   progressBar.Visible := oscilloBis.visible;
   if agilent.usb=oLibUsb
      then caption := 'Diagramme de Bode auto, mesures par Agilent DSO3000 USB'
      else caption := 'Diagramme de Bode auto, mesures par '+ agilent.identificateur;
   if agilent.infiniVision
      then GBFlabel.caption := 'Commande du GBF interne de '+agilent.identificateur
      else GBFlabel.caption := 'Commande du GBF '+gbf.identificateur;
   if GBFinterne
      then VeffEdit.maxValue := 1.75
      else VeffEdit.maxValue := 7;
   incertitudeComposee := iConstructeur;
   InitOscillo;
end;

procedure TBodeForm.EditMiniChange(Sender: TObject);
begin
     if BodeManuelCB.checked
        then EditMaxi.minValue := EditMini.value+NbreMin*EditPas.value
        else EditMaxi.minValue := EditMini.value*10;
     grapheMult.voies[voieF].mini := EditMini.value;
     oscillo.repaint;
end;

procedure TBodeForm.EditMiniExit(Sender: TObject);
begin
    oscillo.repaint
end;

procedure TBodeForm.EditMaxiChange(Sender: TObject);
begin
     if BodeManuelCB.checked
         then EditMini.maxValue := EditMaxi.value-NbreMin*EditPas.value
         else EditMini.maxValue := EditMaxi.value/10;
     grapheMult.voies[voieF].maxi := EditMaxi.value;
     oscillo.repaint;
end;

procedure TBodeForm.EditMaxiExit(Sender: TObject);
begin
    oscillo.repaint
end;

procedure TBodeForm.VeffEditChange(Sender: TObject);
begin
   if GBFinterne
      then begin
        agilent.Veff := VeffEdit.value;
        VeffEdit.value := agilent.Veff;
        grapheMult.voies[1].calibre := Agilent.setChanScaleEff(agilent.Veff,1);
      end
      else begin
         GBF.Veff := VeffEdit.value;
         VeffEdit.value := GBF.Veff;
         grapheMult.voies[1].calibre := Agilent.setChanScaleEff(GBF.Veff,1);
      end;
   PostMessage(handle,WM_Acq_Point,1,0)
end;

procedure TBodeForm.VeffEditExit(Sender: TObject);
begin
   PostMessage(handle,WM_Acq_Point,1,0)
end;

procedure TBodeForm.FormDestroy(Sender: TObject);
begin
     GrapheMult.Free;
     GrapheOsc.free;
     BodeForm := nil;
end;

procedure TBodeForm.FormResize(Sender: TObject);
begin
     if oscilloBis.visible then oscilloBis.Height := 2*clientHeight div 5
end;

procedure TBodeForm.StopActionExecute(Sender: TObject);
begin
     Agilent.stop := true;
     StopAction.enabled := false;
     UnLockAction.enabled := true;
     EnregistreAction.Enabled := true;
end;

procedure TBodeForm.TrackBarMouseUp(Sender: TObject; Button: TMouseButton;
                                Shift: TShiftState; X, Y: Integer);
begin
    with grapheMult.voies[voieF] do if axeLog
       then frequenceCourante := mini*power((maxi/mini),frequenceTB.Position/frequenceTB.max)
       else frequenceCourante := mini+(maxi-mini)*frequenceTB.Position/frequenceTB.max;
    PostMessage(handle,WM_Acq_Point,1,0);
end;

procedure TBodeForm.UnLockActionExecute(Sender: TObject);
begin
    agilent.unLock;
    if GBFinterne then GBF.unLock;
  //  unLockAction.enabled := false;
end;

procedure TBodeForm.OscilloBisPaint(Sender: TObject);
begin
     GrapheOsc.DrawG
end;

procedure TBodeForm.NewPageActionExecute(Sender: TObject);
begin
    EnvoieDonnees(eAdd)
end;

procedure TBodeForm.WMAcqPoint(var Msg: Tmessage);
begin
   envoieDemande
end;

procedure TBodeForm.EnvoieDemande;
var i : indiceVoieMult;
    exposant,mantisse,coeff : double;
    ch : integer;
    rapport : double;
    newVeff : double;
    Vmin : double;
label fin;
begin with grapheMult do begin
     setBoutons(false);
     if GbfInterne then begin
        agilent.frequence := frequenceCourante;
        agilent.sinus(false);
     end
     else begin
        GBF.frequence := frequenceCourante;
        GBF.sinus(false);
     end;
     Agilent.setTimeScale(frequenceCourante); // attente : 1 s
     sleep(1000);
     try
     agilent.stop := false;
     for ch := voieF to voiePhase do
         voies[ch].erreurLecture := false;
     LabelErreurLecture.visible := false;
     Agilent.Flush;
     erreurLectureGlb := false;
     if phaseCB.checked and
       (agilent.usb=olibusb) then begin
           Agilent.litValeurs(wScreen);
           if agilent.stop then Goto fin;
     end;
     with voies[voieF] do begin
         ValeurCourante := frequenceCourante;
         LabelVoie.caption := ' '+nom+'='+strValeur(valeurCourante);
     end;
//     if agilent.infiniVision then agilent.RootCommand('STOP');
      //  agilent.RootCommand('DIG');
     with voies[voie1] do begin // GBF
         if not isNan(valeurCourante) then oldValeur := valeurCourante;
         ValeurCourante := Agilent.GetRMSAC(numVoie);
         erreurLecture := isNan(ValeurCourante);
         erreurLectureGlb := erreurLectureGlb or erreurLecture;
         if erreurLecture then Goto fin;
     end;
     with voies[voie2] do begin // sortie
         if not isNan(valeurCourante) then oldValeur := valeurCourante;
         ValeurCourante := Agilent.GetRMSAC(numVoie);
         erreurLecture := isNan(ValeurCourante);
         if erreurLecture and (calibre<5) then begin // signal trop lev
             calibre := agilent.setChanScaleCalibre(calibre*2.6,2);
               // passage 1/2/5/10, donc *2.5 minimum
            (*if agilent.usb=oLibUsb
               then agilent.KeyCommand('CH2_SCALE_DEC')
               else agilent.KeyCommand('CH2_VOLT_DEC'); *)
             Application.ProcessMessages;// pour le stop
             if not agilent.stop then PostMessage(handle,WM_Acq_Point,1,0);
             exit;
         end;
         if erreurLecture and (calibre>=5) and (VeffEdit.Value>0.1) then begin
          // on diminue le signal d'entre
             newVeff := VeffEdit.Value/2;
             if gbfInterne then begin
                agilent.Veff := newVeff;
                agilent.sinus(false);
             end
             else begin
                GBF.Veff := newVeff;
                GBF.sinus(false);
             end;
             VeffEdit.Value := newVeff;
             voies[voie1].calibre := agilent.setChanScaleEff(newVeff,1);
             Application.ProcessMessages;// pour le stop
             if not agilent.stop then PostMessage(handle,WM_Acq_Point,1,0);
             exit;
         end;
         if not erreurLecture and (valeurCourante<calibre) then begin // signal trop faible
         // Veff max = calibre * 2.8
             if gbfInterne then Vmin := agilent.VeffMax else Vmin := GBF.VeffMax;
             Vmin := Vmin/2;
             if (calibre<1) and (voies[voie1].valeurCourante<Vmin) then begin
             // on augmente la tension d'entre
                newVeff := voies[voie1].valeurCourante*2;
                if gbfInterne then begin
                   agilent.Veff := newVeff;
                   agilent.sinus(false);
                end
                else begin
                   GBF.Veff := newVeff;
                   GBF.sinus(false);
                end;
                VeffEdit.Value := newVeff;
                voies[voie1].calibre := agilent.setChanScaleEff(newVeff,1);
                Application.ProcessMessages;// pour le stop
                if not agilent.stop then PostMessage(handle,WM_Acq_Point,1,0);
                exit;
             end;
             // on diminue le calibre
             calibre := agilent.setChanScaleCalibre(calibre/2.6,2);
             Application.ProcessMessages;// pour le stop
             if not agilent.stop then PostMessage(handle,WM_Acq_Point,1,0);
             exit;
         end;
         erreurLectureGlb := erreurLectureGlb or erreurLecture;
         if erreurLecture then Goto fin;
     end;
     if phaseCB.checked then with voies[voiePhase] do begin
         labelVoie.hint := '';
         if not isNan(valeurCourante) then oldValeur := valeurCourante;
         ValeurCourante := agilent.phase;
         erreurLecture := isNan(ValeurCourante);
         erreurLectureGlb := erreurLectureGlb or erreurLecture;
         LabelVoie.caption := ' '+nom+'='+strValeur(valeurCourante);
         if erreurLecture then goto fin;
     end;
     for i := succ(voieF) to VoiePhase do
         voies[i].setIncertitude;
     with voies[voieGain] do begin
            if not isNan(valeurCourante) then oldValeur := valeurCourante;
            valeurCourante := voies[voie2].valeurCourante/voies[voie1].valeurCourante;
            incertitudeCourante :=  valeurCourante*sqrt(
                sqr(voies[voie1].incertitudeCourante/voies[voie1].valeurCourante)+
                sqr(voies[voie2].incertitudeCourante/voies[voie2].valeurCourante));
            LabelVoie.caption := ' '+nom+'='+strValeur(valeurCourante);
            if valeurCourante>maxi then begin { 512 par ex. }
               exposant := intMaths(log10(valeurCourante)); { 2 }
               coeff := power(10,exposant); { 100 }
               mantisse := int(abs(valeurCourante)/coeff); { 5 }
               maxi := (mantisse+1)*coeff; { 600 }
               oscillo.repaint;
            end;
            if valeurCourante<miniLog then begin
               exposant := intMaths(log10(valeurCourante));
               coeff := power(10,exposant);
               mantisse := int(abs(valeurCourante)/coeff);
               if mantisse>1
                  then miniLog := (mantisse-1)*coeff
                  else miniLog := 9*coeff/10;
               if miniLog<1e-6 then miniLog := 1e-6;
               oscillo.repaint;
            end;
            if not BodeManuelCB.checked and (grapheMult.NbrePoints>2) then begin
               try
               rapport := valeurCourante/valeur[pred(NbrePoints)];
               rapport := abs(log10(rapport)); // limite  2 dB
               if (rapport>0.2) and
                 (multFreq>multMin) then begin   // 4 dB
// on revient en arrire avec un pas trois fois plus petit
                     frequenceCourante := frequenceCourante/multFreq;
                     multFreq := power(multFreq,0.33);
               end;
               if (rapport<0.05) and
                  (multFreq<multMax) then // on acclre en dessous de 1 dB
                   multFreq := power(multFreq,1.5);
               except

               end;
            end;
        end; // voieGain
        if acqEnCours
           then enregistrePointCourant
           else oscillo.repaint;
     fin :
     if ErreurLectureGlb then begin
        agilent.stop := true;
        Oscillo.repaint;
     end;
     LabelErreurLecture.visible := ErreurLectureGlb;
     if oscilloBis.visible then oscilloBis.repaint;
     Application.ProcessMessages;// pour le stop
     if agilent.stop
        then begin
           acqEnCours := false;
           acqAsauver := grapheMult.nbrePoints>3;
           setBoutons(true);
        end
        else if acqEnCours
        then begin
           if BodeManuelCB.checked
              then frequenceCourante := frequenceCourante+EditPas.value
              else frequenceCourante := frequenceCourante*multFreq;
           if frequenceCourante<=grapheMult.voies[voieF].maxi*1.05
               then PostMessage(handle,WM_Acq_Point,1,0)
               else begin
                  acqEnCours := false;
                  acqAsauver := grapheMult.nbrePoints>3;
                  setBoutons(true);
               end;
        end
        else setBoutons(true); // not acqEnCours
     except
        setBoutons(true);
     end;
end end;

procedure TBodeForm.UndoActionExecute(Sender: TObject);
begin // Supprimer dernier point
     Agilent.stop := true;
     with grapheMult do if NbrePoints>0 then begin
        dec(NbrePoints);
        if nbrePoints=0
           then frequenceCourante := voies[voieF].mini
           else frequenceCourante := voies[voieF].valeur[pred(nbrePoints)];
     end;
     Oscillo.repaint;
     setBoutons(true);
end;

procedure TBodeForm.AideActionExecute(Sender: TObject);
begin
    if AideBodeForm=nil then
       application.CreateForm(TaideBodeForm,AideBodeForm);
    AideBodeForm.showModal;
end;

procedure TBodeForm.BodeManuelCBClick(Sender: TObject);
begin
  EDitPas.Visible := BodeManuelCB.checked;
  PasLabel.Visible := BodeManuelCB.checked;
end;

procedure TBodeForm.dbCBClick(Sender: TObject);
begin with grapheMult.voies[voieGain] do begin
     axeLog := dbCB.checked;
     if dbCB.checked
        then nomUnite := 'dB'
        else nomUnite := '';
     GainLabel.caption := ' '+nom+'='+strValeur(valeurCourante);
     oscillo.repaint;
end end;

procedure TBodeForm.initOscillo;
var ch : integer;
    v : indiceVoieMult;
    pasMax,pasMin : double;
begin
   LabelInfo.Visible := true;
   LabelInfo.Caption := ' Rglage de l''oscilloscope : patientez ';
   labelInfo.Update;
//   agilent.setPhase12;
   for ch := 1 to 2 do begin
      agilent.chanCommand('OFFS 0',ch);
      agilent.chanCommand('COUP AC',ch);
      agilent.chanCommand('DISP ON',ch);
      agilent.chanCommand('PROB 1',ch);
   end;
   with grapheMult do for v := voieF to voieGain do
        voies[v].oldValeur := 0;
   agilent.trigCommand('COUP AC');
   agilent.writeString(':TRIG:MODE EDGE');
   agilent.trigCommand('LEV 0');
   agilent.trigCommand('SOUR CHAN1');
   agilent.writeString(':TRIG:SWE NORM');
   frequenceCourante := grapheMult.voies[voieF].mini;
   if GbfInterne
     then begin
        agilent.frequence := frequenceCourante;
        agilent.Veff := VeffEdit.value;
        agilent.sinus(false);
     end
     else begin
        GBF.frequence := frequenceCourante;
        GBF.Veff := VeffEdit.value;
        GBF.sinus(false);
     end;
   sleep(100); // attente fin transitoire
   Agilent.setTimeScale(frequenceCourante); // attente : 1/2 s + 5 priodes en ms
   sleep(500 + round(5*1000/frequenceCourante));
   if GBFinterne then begin
       grapheMult.voies[1].calibre := agilent.setChanScaleEff(agilent.Veff,1);
       grapheMult.voies[2].calibre := agilent.setChanScaleEff(agilent.Veff,2);
   end
   else begin
        grapheMult.voies[1].calibre := agilent.setChanScaleEff(GBF.Veff,1);
        grapheMult.voies[2].calibre := agilent.setChanScaleEff(GBF.Veff,2);
   end;
   multFreq := multMax;
   LabelInfo.Caption := ' Rglage du GBF : patientez ';
   LabelInfo.Update;
   if GbfInterne
      then agilent.sinus(true)
      else GBF.sinus(true);
   if BodeManuelCB.Checked then begin
      pasMax := (EditMaxi.value-EditMini.value)/NbreMin;
      pasMin := (EditMaxi.value-EditMini.value)/NbreMax;
      if EditPas.value<pasMin then
         EditPas.Value := pasMin;
      if EditPas.value>pasMax then
         EditPas.Value := pasMax;
   end;
   LabelInfo.Visible := false;
   oscillo.repaint;
end;

procedure TBodeForm.setBoutons(actif : boolean);
begin
    frequenceTB.Enabled := actif;
    VeffEdit.Enabled := actif;
    EnregistreAction.enabled := actif;
    stopAction.enabled := not actif;
    UnLockAction.Enabled := actif;
    if actif then UnLockActionExecute(nil);
    ResetAction.enabled := not acqEnCours and (grapheMult.NbrePoints>0);
    RegressiAction.enabled := not acqEnCours and (grapheMult.NbrePoints>3);
    FileSaveAction.Enabled := RegressiAction.Enabled;
    NewPageAction.enabled := FichierRegressiCree and RegressiAction.enabled;
    UndoAction.enabled := ResetAction.enabled;
    BodeManuelCB.Enabled := actif;
end;

end.


