unit Voies;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils, dialogs,
  agilentU, jmmUtil, HPgrapheMult, ComCtrls;

type
  TVoiesDlg = class(TForm)
    ActiveBtn: TBitBtn;
    CancelBtn: TBitBtn;
    ListeCommande: TListBox;
    GroupBox2: TGroupBox;
    EditMaxi: TEdit;
    Bevel1: TBevel;
    UniteLabel: TLabel;
    GroupBox3: TGroupBox;
    EditNom: TEdit;
    GroupBox1: TGroupBox;
    EditComm: TEdit;
    StatusBar1: TStatusBar;
    procedure ActiveBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ListeCommandeClick(Sender: TObject);
  private
    ModifNom : boolean;
  public
    VoieLue : Tvoie;
  end;

var
  VoiesDlg: TVoiesDlg;

implementation

{$R *.DFM}

procedure TVoiesDlg.ActiveBtnClick(Sender: TObject);
var voieAgilent : TvoieAgilent;
begin
     if ListeCommande.itemIndex>=0 then begin
        voieAgilent := VoiesAgilent[ListeCommande.itemIndex];
        voieLue.Command := voieAgilent.Command;
        voieLue.Signif := voieAgilent.Signif;
        voieLue.nomUnite := voieAgilent.nomUnite;
        voieLue.positive := voieAgilent.positive;
        voieLue.CalculIncertitude := voieAgilent.CalculIncertitude;
     end;
     voieLue.Nom := EditNom.text;
     if editComm.text<>'' then voieLue.Signif := EditComm.text;
     voieLue.Maxi := StrToFloatWin(EditMaxi.text);
     if voieLue.Positive
        then voieLue.Mini := 0
        else voieLue.Mini := -voieLue.Maxi
end;

procedure TVoiesDlg.FormCreate(Sender: TObject);
var i : integer;
begin
    listeCommande.clear;
    for i := 0 to MaxVoieMeasure do
        listeCommande.items.add(VoiesAgilent[i].signif);
end;

procedure TVoiesDlg.FormActivate(Sender: TObject);
begin with voieLue do begin
     caption := 'Configuration de la voie'+intToStr(numVoie);
     ModifNom := false;
     try
     ListeCommande.ItemIndex := ListeCommande.items.indexOf(signif);
     except
         ListeCommande.ItemIndex := 0;
     end;
     EditMaxi.text := FloatToStr(Maxi);
     EditNom.text := nom;
     EditComm.text := commentaire;
     UniteLabel.caption := nomUnite;
end end;

procedure TVoiesDlg.ListeCommandeClick(Sender: TObject);
var voieAgilent : TvoieAgilent;
    oldUnite : string;
begin
     voieAgilent := VoiesAgilent[ListeCommande.itemIndex];
     oldUnite := UniteLabel.caption;
     UniteLabel.caption := voieAgilent.nomUnite;
     if ModifNom and (oldUnite<>voieAgilent.nomUnite) then begin
        EditNom.text := voieAgilent.Nom;
        EditNom.text := EditNom.text + IntToStr(voieLue.NumVoie);
        EditMaxi.text := FloatToStr(voieAgilent.Maxi);
     end;
end;

end.
